Whamcloud - gitweb
a229c616da9f8dc71c4f22b638be6d7846003100
[fs/lustre-release.git] / lustre / tests / sanityn.sh
1 #!/bin/bash
2
3 set -e
4
5 ONLY=${ONLY:-"$*"}
6 # bug number for skipped test: 3192 15528/3811 16929 9977 15528/11549 18080
7 ALWAYS_EXCEPT="                14b  19         22    28   29          35    $SANITYN_EXCEPT"
8 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
9
10 # bug number for skipped test:                                                    12652 12652
11 grep -q 'Enterprise Server 10' /etc/SuSE-release && ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
12
13 # Tests that fail on uml
14 [ "$UML" = "true" ] && EXCEPT="$EXCEPT 7"
15
16 # It will be ported soon.
17 EXCEPT="$EXCEPT 22"
18
19 SRCDIR=`dirname $0`
20 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
21
22 SIZE=${SIZE:-40960}
23 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
24 GETSTRIPE=${GETSTRIPE:-lfs getstripe}
25 SETSTRIPE=${SETSTRIPE:-lstripe}
26 MCREATE=${MCREATE:-mcreate}
27 OPENFILE=${OPENFILE:-openfile}
28 OPENUNLINK=${OPENUNLINK:-openunlink}
29 export TMP=${TMP:-/tmp}
30 MOUNT_2=${MOUNT_2:-"yes"}
31 CHECK_GRANT=${CHECK_GRANT:-"yes"}
32 GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
33
34 SAVE_PWD=$PWD
35
36 export NAME=${NAME:-local}
37
38 LUSTRE=${LUSTRE:-`dirname $0`/..}
39 . $LUSTRE/tests/test-framework.sh
40 CLEANUP=${CLEANUP:-:}
41 SETUP=${SETUP:-:}
42 init_test_env $@
43 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
44 init_logging
45
46 [ "$SLOW" = "no" ] && EXCEPT_SLOW="12 16 23 33a"
47
48 FAIL_ON_ERROR=false
49
50 SETUP=${SETUP:-:}
51 TRACE=${TRACE:-""}
52
53 check_and_setup_lustre
54
55 LOVNAME=`lctl get_param -n llite.*.lov.common_name | tail -n 1`
56 OSTCOUNT=`lctl get_param -n lov.$LOVNAME.numobd`
57
58 assert_DIR
59 rm -rf $DIR1/[df][0-9]* $DIR1/lnk
60
61 SAMPLE_FILE=$TMP/$(basename $0 .sh).junk
62 dd if=/dev/urandom of=$SAMPLE_FILE bs=1M count=1
63
64 # $RUNAS_ID may get set incorrectly somewhere else
65 [ $UID -eq 0 -a $RUNAS_ID -eq 0 ] && error "\$RUNAS_ID set to 0, but \$UID is also 0!"
66
67 check_runas_id $RUNAS_ID $RUNAS_GID $RUNAS
68
69 build_test_filter
70
71 mkdir -p $MOUNT2
72 mount_client $MOUNT2
73
74 test_1a() {
75         touch $DIR1/f1
76         [ -f $DIR2/f1 ] || error
77 }
78 run_test 1a "check create on 2 mtpt's =========================="
79
80 test_1b() {
81         chmod 777 $DIR2/f1
82         $CHECKSTAT -t file -p 0777 $DIR1/f1 || error
83         chmod a-x $DIR2/f1
84 }
85 run_test 1b "check attribute updates on 2 mtpt's ==============="
86
87 test_1c() {
88         $CHECKSTAT -t file -p 0666 $DIR1/f1 || error
89 }
90 run_test 1c "check after remount attribute updates on 2 mtpt's ="
91
92 test_1d() {
93         rm $DIR2/f1
94         $CHECKSTAT -a $DIR1/f1 || error
95 }
96 run_test 1d "unlink on one mountpoint removes file on other ===="
97
98 test_2a() {
99         touch $DIR1/f2a
100         ls -l $DIR2/f2a
101         chmod 777 $DIR2/f2a
102         $CHECKSTAT -t file -p 0777 $DIR1/f2a || error
103 }
104 run_test 2a "check cached attribute updates on 2 mtpt's ========"
105
106 test_2b() {
107         touch $DIR1/f2b
108         ls -l $DIR2/f2b
109         chmod 777 $DIR1/f2b
110         $CHECKSTAT -t file -p 0777 $DIR2/f2b || error
111 }
112 run_test 2b "check cached attribute updates on 2 mtpt's ========"
113
114 # NEED TO SAVE ROOT DIR MODE
115 test_2c() {
116         chmod 777 $DIR1
117         $CHECKSTAT -t dir -p 0777 $DIR2 || error
118 }
119 run_test 2c "check cached attribute updates on 2 mtpt's root ==="
120
121 test_2d() {
122         chmod 755 $DIR1
123         $CHECKSTAT -t dir -p 0755 $DIR2 || error
124 }
125 run_test 2d "check cached attribute updates on 2 mtpt's root ==="
126
127 test_2e() {
128         chmod 755 $DIR1
129         ls -l $DIR1
130         ls -l $DIR2
131         chmod 777 $DIR1
132         $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 || error
133 }
134 run_test 2e "check chmod on root is propagated to others"
135
136 test_3() {
137         ( cd $DIR1 ; ln -s this/is/good $tfile )
138         [ "this/is/good" = "`perl -e 'print readlink("'$DIR2/$tfile'");'`" ] ||
139                 error "link $DIR2/$tfile not as expected"
140 }
141 run_test 3 "symlink on one mtpt, readlink on another ==========="
142
143 test_4() {
144         multifstat $DIR1/f4 $DIR2/f4
145 }
146 run_test 4 "fstat validation on multiple mount points =========="
147
148 test_5() {
149         mcreate $DIR1/f5
150         $TRUNCATE $DIR2/f5 100
151         $CHECKSTAT -t file -s 100 $DIR1/f5 || error
152         rm $DIR1/f5
153 }
154 run_test 5 "create a file on one mount, truncate it on the other"
155
156 test_6() {
157         openunlink $DIR1/$tfile $DIR2/$tfile || \
158                 error "openunlink $DIR1/$tfile $DIR2/$tfile"
159 }
160 run_test 6 "remove of open file on other node =================="
161
162 test_7() {
163         local dir=d7
164         opendirunlink $DIR1/$dir $DIR2/$dir || \
165                 error "opendirunlink $DIR1/$dir $DIR2/$dir"
166 }
167 run_test 7 "remove of open directory on other node ============="
168
169 test_8() {
170         opendevunlink $DIR1/$tfile $DIR2/$tfile || \
171                 error "opendevunlink $DIR1/$tfile $DIR2/$tfile"
172 }
173 run_test 8 "remove of open special file on other node =========="
174
175 test_9() {
176         MTPT=1
177         local dir
178         > $DIR2/f9
179         for C in a b c d e f g h i j k l; do
180                 dir=`eval echo \\$DIR$MTPT`
181                 echo -n $C >> $dir/f9
182                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
183         done
184         [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
185                 error "`od -a $DIR1/f9` != abcdefghijkl"
186 }
187 run_test 9 "append of file with sub-page size on multiple mounts"
188
189 test_10a() {
190         MTPT=1
191         local dir
192         OFFSET=0
193         > $DIR2/f10
194         for C in a b c d e f g h i j k l; do
195                 dir=`eval echo \\$DIR$MTPT`
196                 echo -n $C | dd of=$dir/f10 bs=1 seek=$OFFSET count=1
197                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
198                 OFFSET=`expr $OFFSET + 1`
199         done
200         [ "`cat $DIR1/f10`" = "abcdefghijkl" ] || \
201                 error "`od -a $DIR1/f10` != abcdefghijkl"
202 }
203 run_test 10a "write of file with sub-page size on multiple mounts "
204
205 test_10b() {
206         # create a seed file
207         yes "R" | head -c 4000 >$TMP/f10b-seed
208         dd if=$TMP/f10b-seed of=$DIR1/f10b bs=3k count=1 || error "dd $DIR1"
209
210         $TRUNCATE $DIR1/f10b 4096 || error "truncate 4096"
211
212         dd if=$DIR2/f10b of=$TMP/f10b-lustre bs=4k count=1 || error "dd $DIR2"
213
214         # create a test file locally to compare
215         dd if=$TMP/f10b-seed of=$TMP/f10b bs=3k count=1 || error "dd random"
216         $TRUNCATE $TMP/f10b 4096 || error "truncate 4096"
217         cmp $TMP/f10b $TMP/f10b-lustre || error "file miscompare"
218         rm $TMP/f10b $TMP/f10b-lustre $TMP/f10b-seed
219 }
220 run_test 10b "write of file with sub-page size on multiple mounts "
221
222 test_11() {
223         mkdir $DIR1/d11
224         multiop_bg_pause $DIR1/d11/f O_c || return 1
225         MULTIPID=$!
226         cp -p /bin/ls $DIR1/d11/f
227         $DIR2/d11/f
228         RC=$?
229         kill -USR1 $MULTIPID
230         wait $MULTIPID || error
231         [ $RC -eq 0 ] && error || true
232 }
233 run_test 11 "execution of file opened for write should return error ===="
234
235 test_12() {
236        DIR=$DIR DIR2=$DIR2 sh lockorder.sh
237 }
238 run_test 12 "test lock ordering (link, stat, unlink) ==========="
239
240 test_13() {     # bug 2451 - directory coherency
241        rm -rf $DIR1/d13
242        mkdir $DIR1/d13 || error
243        cd $DIR1/d13 || error
244        ls
245        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
246        ls
247        rm -f $DIR2/d13/f13 || error
248        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
249        # need to run it twice
250        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
251        ls
252        rm -f $DIR2/d13/f13 || error
253        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
254 }
255 run_test 13 "test directory page revocation ===================="
256
257 test_14() {
258         mkdir -p $DIR1/$tdir
259         cp -p /bin/ls $DIR1/$tdir/$tfile
260         multiop_bg_pause $DIR1/$tdir/$tfile Ow_c || return 1
261         MULTIPID=$!
262
263         $DIR2/$tdir/$tfile && error || true
264         kill -USR1 $MULTIPID
265         wait $MULTIPID || return 2
266 }
267 run_test 14 "execution of file open for write returns -ETXTBSY ="
268
269 test_14a() {
270         mkdir -p $DIR1/d14
271         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
272         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
273         MULTIOP_PID=$!
274         multiop $DIR2/d14/multiop Oc && error "expected error, got success"
275         kill -USR1 $MULTIOP_PID || return 2
276         wait $MULTIOP_PID || return 3
277         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
278 }
279 run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
280
281 test_14b() { # bug 3192, 7040
282         mkdir -p $DIR1/d14
283         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
284         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
285         MULTIOP_PID=$!
286         $TRUNCATE $DIR2/d14/multiop 0 && kill -9 $MULTIOP_PID && \
287                 error "expected truncate error, got success"
288         kill -USR1 $MULTIOP_PID || return 2
289         wait $MULTIOP_PID || return 3
290         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
291         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
292 }
293 run_test 14b "truncate of executing file returns -ETXTBSY ======"
294
295 test_14c() { # bug 3430, 7040
296         mkdir -p $DIR1/d14
297         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
298         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
299         MULTIOP_PID=$!
300         cp /etc/hosts $DIR2/d14/multiop && error "expected error, got success"
301         kill -USR1 $MULTIOP_PID || return 2
302         wait $MULTIOP_PID || return 3
303         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
304         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
305 }
306 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
307
308 test_14d() { # bug 10921
309         mkdir -p $DIR1/d14
310         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
311         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
312         MULTIOP_PID=$!
313         log chmod
314         chmod 600 $DIR1/d14/multiop || error "chmod failed"
315         kill -USR1 $MULTIOP_PID || return 2
316         wait $MULTIOP_PID || return 3
317         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
318         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
319 }
320 run_test 14d "chmod of executing file is still possible ========"
321
322 test_15() {     # bug 974 - ENOSPC
323         echo "PATH=$PATH"
324         sh oos2.sh $MOUNT1 $MOUNT2
325         grant_error=`dmesg | grep "> available"`
326         [ -z "$grant_error" ] || error "$grant_error"
327 }
328 run_test 15 "test out-of-space with multiple writers ==========="
329
330 test_16() {
331         rm -f $MOUNT1/fsxfile
332         lfs setstripe $MOUNT1/fsxfile -c -1 # b=10919
333         fsx -c 50 -p 100 -N 2500 -l $((SIZE * 256)) -S 0 $MOUNT1/fsxfile $MOUNT2/fsxfile
334 }
335 run_test 16 "2500 iterations of dual-mount fsx ================="
336
337 test_17() { # bug 3513, 3667
338         remote_ost_nodsh && skip "remote OST with nodsh" && return
339
340         lfs setstripe $DIR1/$tfile -i 0 -c 1
341         cp $SAMPLE_FILE $DIR1/$tfile
342         cancel_lru_locks osc > /dev/null
343         #define OBD_FAIL_ONCE|OBD_FAIL_LDLM_CREATE_RESOURCE    0x30a
344         do_facet ost1 lctl set_param fail_loc=0x8000030a
345         ls -ls $DIR1/$tfile | awk '{ print $1,$6 }' > $DIR1/$tfile-1 & \
346         ls -ls $DIR2/$tfile | awk '{ print $1,$6 }' > $DIR2/$tfile-2
347         wait
348         diff -u $DIR1/$tfile-1 $DIR2/$tfile-2 || error "files are different"
349 }
350 run_test 17 "resource creation/LVB creation race ==============="
351
352 test_18() {
353         $LUSTRE/tests/mmap_sanity -d $MOUNT1 -m $MOUNT2
354         sync; sleep 1; sync
355 }
356 run_test 18 "mmap sanity check ================================="
357
358 test_19() { # bug3811
359         [ -d /proc/fs/lustre/obdfilter ] || return 0
360
361         MAX=`lctl get_param -n obdfilter.*.readcache_max_filesize | head -n 1`
362         lctl set_param -n obdfilter.*OST*.readcache_max_filesize=4096
363         dd if=/dev/urandom of=$TMP/f19b bs=512k count=32
364         SUM=`cksum $TMP/f19b | cut -d" " -f 1,2`
365         cp $TMP/f19b $DIR1/f19b
366         for i in `seq 1 20`; do
367                 [ $((i % 5)) -eq 0 ] && log "test_18 loop $i"
368                 cancel_lru_locks osc > /dev/null
369                 cksum $DIR1/f19b | cut -d" " -f 1,2 > $TMP/sum1 & \
370                 cksum $DIR2/f19b | cut -d" " -f 1,2 > $TMP/sum2
371                 wait
372                 [ "`cat $TMP/sum1`" = "$SUM" ] || \
373                         error "$DIR1/f19b `cat $TMP/sum1` != $SUM"
374                 [ "`cat $TMP/sum2`" = "$SUM" ] || \
375                         error "$DIR2/f19b `cat $TMP/sum2` != $SUM"
376         done
377         lctl set_param -n obdfilter.*OST*.readcache_max_filesize=$MAX
378         rm $DIR1/f19b
379 }
380 run_test 19 "test concurrent uncached read races ==============="
381
382 test_20() {
383         mkdir $DIR1/d20
384         cancel_lru_locks osc
385         CNT=$((`lctl get_param -n llite.*.dump_page_cache | wc -l`))
386         multiop $DIR1/f20 Ow8190c
387         multiop $DIR2/f20 Oz8194w8190c
388         multiop $DIR1/f20 Oz0r8190c
389         cancel_lru_locks osc
390         CNTD=$((`lctl get_param -n llite.*.dump_page_cache | wc -l` - $CNT))
391         [ $CNTD -gt 0 ] && \
392             error $CNTD" page left in cache after lock cancel" || true
393 }
394 run_test 20 "test extra readahead page left in cache ===="
395
396 cleanup_21() {
397         trap 0
398         umount $DIR1/d21
399 }
400
401 test_21() { # Bug 5907
402         mkdir $DIR1/d21
403         mount /etc $DIR1/d21 --bind || error "mount failed" # Poor man's mount.
404         trap cleanup_21 EXIT
405         rmdir -v $DIR1/d21 && error "Removed mounted directory"
406         rmdir -v $DIR2/d21 && echo "Removed mounted directory from another mountpoint, needs to be fixed"
407         test -d $DIR1/d21 || error "Mounted directory disappeared"
408         cleanup_21
409         test -d $DIR2/d21 || test -d $DIR1/d21 && error "Removed dir still visible after umount"
410         true
411 }
412 run_test 21 " Try to remove mountpoint on another dir ===="
413
414 test_23() { # Bug 5972
415         echo "others should see updated atime while another read" > $DIR1/f23
416         
417         # clear the lock(mode: LCK_PW) gotten from creating operation
418         cancel_lru_locks osc
419         
420         time1=`date +%s`        
421         #MAX_ATIME_DIFF 60, we update atime only if older than 60 seconds
422         sleep 61
423         
424         multiop_bg_pause $DIR1/f23 or20_c || return 1
425         # with SOM and opencache enabled, we need to close a file and cancel
426         # open lock to get atime propogated to MDS
427         kill -USR1 $!
428         cancel_lru_locks mdc
429
430         time2=`stat -c "%X" $DIR2/f23`
431
432         if (( $time2 <= $time1 )); then
433                 error "atime doesn't update among nodes"
434         fi
435
436         rm -f $DIR1/f23 || error "rm -f $DIR1/f23 failed"
437         true
438 }
439 run_test 23 " others should see updated atime while another read===="
440
441 test_24a() {
442         touch $DIR1/$tfile
443         lfs df || error "lfs df failed"
444         lfs df -ih || error "lfs df -ih failed"
445         lfs df -h $DIR1 || error "lfs df -h $DIR1 failed"
446         lfs df -i $DIR2 || error "lfs df -i $DIR2 failed"
447         lfs df $DIR1/$tfile || error "lfs df $DIR1/$tfile failed"
448         lfs df -ih $DIR2/$tfile || error "lfs df -ih $DIR2/$tfile failed"
449         
450         OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
451 #       OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
452         lctl --device %$OSC deactivate
453         lfs df -i || error "lfs df -i with deactivated OSC failed"
454         lctl --device %$OSC recover
455         lfs df || error "lfs df with reactivated OSC failed"
456 }
457 run_test 24a "lfs df [-ih] [path] test ========================="
458
459 test_24b() {
460         touch $DIR1/$tfile
461         fsnum=`lfs df | grep -c "filesystem summary:"`
462         [ $fsnum -eq 2 ] || error "lfs df shows $fsnum != 2 filesystems."
463 }
464 run_test 24b "lfs df should show both filesystems ==============="
465
466 test_25() {
467         [ `lctl get_param -n mdc.*-mdc-*.connect_flags | grep -c acl` -lt 2 ] && \
468             skip "must have acl, skipping" && return
469
470         mkdir -p $DIR1/$tdir
471         touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
472         chmod 0755 $DIR1/$tdir/f1 || error "chmod 0755 $DIR1/$tdir/f1"
473
474         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #1"
475         setfacl -m u:$RUNAS_ID:--- -m g:$RUNAS_GID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #1"
476         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #2"
477         setfacl -m u:$RUNAS_ID:r-x -m g:$RUNAS_GID:r-x $DIR1/$tdir || error "setfacl $DIR2/$tdir #2"
478         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #3"
479         setfacl -m u:$RUNAS_ID:--- -m g:$RUNAS_GID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #3"
480         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #4"
481         setfacl -x u:$RUNAS_ID: -x g:$RUNAS_GID: $DIR1/$tdir || error "setfacl $DIR2/$tdir #4"
482         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #5"
483
484         rm -rf $DIR1/$tdir
485 }
486 run_test 25 "change ACL on one mountpoint be seen on another ==="
487
488 test_26a() {
489         utime $DIR1/f26a -s $DIR2/f26a || error
490 }
491 run_test 26a "allow mtime to get older"
492
493 test_26b() {
494         touch $DIR1/$tfile
495         sleep 1
496         echo "aaa" >> $DIR1/$tfile
497         sleep 1
498         chmod a+x $DIR2/$tfile
499         mt1=`stat -c %Y $DIR1/$tfile`
500         mt2=`stat -c %Y $DIR2/$tfile`
501
502         if [ x"$mt1" != x"$mt2" ]; then
503                 error "not equal mtime, client1: "$mt1", client2: "$mt2"."
504         fi
505 }
506 run_test 26b "sync mtime between ost and mds"
507
508 test_27() {
509         cancel_lru_locks osc
510         lctl clear
511         dd if=/dev/zero of=$DIR2/$tfile bs=$((4096+4))k conv=notrunc count=4 seek=3 &
512         DD2_PID=$!
513         usleep 50
514         log "dd 1 started"
515         
516         dd if=/dev/zero of=$DIR1/$tfile bs=$((16384-1024))k conv=notrunc count=1 seek=4 &
517         DD1_PID=$!
518         log "dd 2 started"
519         
520         sleep 1
521         dd if=/dev/zero of=$DIR1/$tfile bs=8k conv=notrunc count=1 seek=0
522         log "dd 3 finished"
523         lctl set_param -n ldlm.dump_namespaces ""
524         wait $DD1_PID $DD2_PID
525         [ $? -ne 0 ] && lctl dk $TMP/debug || true
526 }
527 run_test 27 "align non-overlapping extent locks from request ==="
528
529 test_28() { # bug 9977
530         ECHO_UUID="ECHO_osc1_UUID"
531         tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
532
533         lfs setstripe $DIR1/$tfile -s 1048576 -i 0 -c 2
534         tOBJID=`lfs getstripe $DIR1/$tfile |grep "^[[:space:]]\+1" |awk '{print $2}'`
535         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2
536
537         $LCTL <<-EOF
538                 newdev
539                 attach echo_client ECHO_osc1 $ECHO_UUID
540                 setup $tOST
541         EOF
542
543         tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{print $1}'`
544         $LCTL --device $tECHOID destroy "${tOBJID}:0"
545
546         $LCTL <<-EOF
547                 cfg_device ECHO_osc1
548                 cleanup
549                 detach
550         EOF
551
552         # reading of 1st stripe should pass
553         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
554         # reading of 2nd stripe should fail (this stripe was destroyed)
555         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 && error
556
557         # now, recreating test file
558         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error
559         # reading of 1st stripe should pass
560         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
561         # reading of 2nd stripe should pass
562         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 || error
563 }
564 run_test 28 "read/write/truncate file with lost stripes"
565
566 test_29() { # bug 10999
567         touch $DIR1/$tfile
568         #define OBD_FAIL_LDLM_GLIMPSE  0x30f
569         lctl set_param fail_loc=0x8000030f
570         ls -l $DIR2/$tfile &
571         usleep 500
572         dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1
573         wait
574 }
575 #bug 11549 - permanently turn test off in b1_5
576 run_test 29 "lock put race between glimpse and enqueue ========="
577
578 test_30() { #bug #11110
579     mkdir -p $DIR1/$tdir
580     cp -f /bin/bash $DIR1/$tdir/bash
581     /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
582     err=$($DIR1/$tdir/bash -c 'sleep 2; openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?')
583     wait
584     [ $err -ne 116 ] && error_ignore 12900 "return code ($err) != -ESTALE" && return
585     true
586 }
587
588 run_test 30 "recreate file race ========="
589
590 test_31a() {
591         mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
592         writes=`LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile count=1 2>&1 |
593                 awk 'BEGIN { FS="+" } /out/ {print $1}'`
594         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
595         lctl set_param fail_loc=0x314
596         reads=`LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
597                awk 'BEGIN { FS="+" } /in/ {print $1}'`
598         [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
599 }
600 run_test 31a "voluntary cancel / blocking ast race=============="
601
602 test_31b() {
603         remote_ost || { skip "local OST" && return 0; }
604         remote_ost_nodsh && skip "remote OST w/o dsh" && return 0
605         mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
606         lfs setstripe $DIR/$tdir/$tfile -i 0 -c 1
607         cp /etc/hosts $DIR/$tdir/$tfile
608         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
609         lctl set_param fail_loc=0x314
610         #define OBD_FAIL_LDLM_OST_FAIL_RACE      0x316
611         do_facet ost1 lctl set_param fail_loc=0x316
612         # Don't crash kernel
613         cat $DIR2/$tdir/$tfile > /dev/null 2>&1
614         lctl set_param fail_loc=0
615         do_facet ost1 lctl set_param fail_loc=0
616         # cleanup: reconnect the client back
617         df $DIR2
618 }
619 run_test 31b "voluntary OST cancel / blocking ast race=============="
620
621 # enable/disable lockless truncate feature, depending on the arg 0/1
622 enable_lockless_truncate() {
623         lctl set_param -n osc.*.lockless_truncate $1
624 }
625
626 test_32a() { # bug 11270
627         local p="$TMP/sanityN-$TESTNAME.parameters"
628         save_lustre_params $HOSTNAME osc.*.lockless_truncate > $p
629         cancel_lru_locks osc
630         enable_lockless_truncate 1
631         rm -f $DIR1/$tfile
632         lfs setstripe -c -1 $DIR1/$tfile
633         dd if=/dev/zero of=$DIR1/$tfile count=10 bs=1M > /dev/null 2>&1
634         clear_osc_stats
635
636         log "checking cached lockless truncate"
637         $TRUNCATE $DIR1/$tfile 8000000
638         $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
639         [ $(calc_osc_stats lockless_truncate) -eq 0 ] ||
640                 error "lockless truncate doesn't use cached locks"
641
642         log "checking not cached lockless truncate"
643         $TRUNCATE $DIR2/$tfile 5000000
644         $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
645         [ $(calc_osc_stats lockless_truncate) -ne 0 ] ||
646                 error "not cached trancate isn't lockless"
647
648         log "disabled lockless truncate"
649         enable_lockless_truncate 0
650         clear_osc_stats
651         $TRUNCATE $DIR2/$tfile 3000000
652         $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
653         [ $(calc_osc_stats lockless_truncate) -eq 0 ] ||
654                 error "lockless truncate disabling failed"
655         rm $DIR1/$tfile
656         # restore lockless_truncate default values
657         restore_lustre_params < $p
658         rm -f $p
659 }
660 run_test 32a "lockless truncate"
661
662 test_32b() { # bug 11270
663         remote_ost_nodsh && skip "remote OST with nodsh" && return
664
665         local node
666         local p="$TMP/sanityN-$TESTNAME.parameters"
667         save_lustre_params $HOSTNAME "osc.*.contention_seconds" > $p
668         for node in $(osts_nodes); do
669                 save_lustre_params $node "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
670                 save_lustre_params $node "ldlm.namespaces.filter-*.contended_locks" >> $p
671                 save_lustre_params $node "ldlm.namespaces.filter-*.contention_seconds" >> $p
672         done
673         clear_osc_stats
674         # agressive lockless i/o settings
675         for node in $(osts_nodes); do
676                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 2000000; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 0; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 60'
677         done
678         lctl set_param -n osc.*.contention_seconds 60
679         for i in $(seq 5); do
680                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
681                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
682         done
683         [ $(calc_osc_stats lockless_write_bytes) -ne 0 ] || error "lockless i/o was not triggered"
684         # disable lockless i/o (it is disabled by default)
685         for node in $(osts_nodes); do
686                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 0; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 32; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 0'
687         done
688         # set contention_seconds to 0 at client too, otherwise Lustre still
689         # remembers lock contention
690         lctl set_param -n osc.*.contention_seconds 0
691         clear_osc_stats
692         for i in $(seq 1); do
693                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
694                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
695         done
696         [ $(calc_osc_stats lockless_write_bytes) -eq 0 ] ||
697                 error "lockless i/o works when disabled"
698         rm -f $DIR1/$tfile
699         restore_lustre_params <$p
700         rm -f $p
701 }
702 run_test 32b "lockless i/o"
703
704 print_jbd_stat () {
705     local dev
706     local mdts=$(get_facets MDS)
707     local varcvs
708     local mds
709
710     local stat=0
711     for mds in ${mdts//,/ }; do
712         varsvc=${mds}_svc
713         dev=$(basename $(do_facet $mds lctl get_param -n osd*.${!varsvc}.mntdev))
714         val=$(do_facet $mds "procfile=/proc/fs/jbd/$dev/info;
715 [ -f \\\$procfile ] || procfile=/proc/fs/jbd2/$dev/info;
716 [ -f \\\$procfile ] || procfile=/proc/fs/jbd2/${dev}\:\\\*/info;
717 cat \\\$procfile | head -1;")
718         val=${val%% *};
719         stat=$(( stat + val))
720     done
721     echo $stat
722 }
723
724 # commit on sharing tests
725 test_33a() {
726     remote_mds_nodsh && skip "remote MDS with nodsh" && return
727
728     [ -n "$CLIENTS" ] || { skip "Need two or more clients" && return 0; }
729     [ $CLIENTCOUNT -ge 2 ] || \
730         { skip "Need two or more clients, have $CLIENTCOUNT" && return 0; }
731
732     local nfiles=${TEST33_NFILES:-10000}
733     local param_file=$TMP/$tfile-params
734
735     save_lustre_params $(comma_list $(mdts_nodes)) "mdt.*.commit_on_sharing" > $param_file
736
737     local COS
738     local jbdold
739     local jbdnew
740     local jbd
741
742     for COS in 0 1; do
743         do_facet $SINGLEMDS lctl set_param mdt.*.commit_on_sharing=$COS
744         avgjbd=0
745         avgtime=0
746         for i in 1 2 3; do
747             do_nodes $CLIENT1,$CLIENT2 "mkdir -p $DIR1/$tdir-\\\$(hostname)-$i"
748
749             jbdold=$(print_jbd_stat)
750             echo "=== START createmany old: $jbdold transaction"
751             local elapsed=$(do_and_time "do_nodes $CLIENT1,$CLIENT2 createmany -o $DIR1/$tdir-\\\$(hostname)-$i/f- -r $DIR2/$tdir-\\\$(hostname)-$i/f- $nfiles > /dev/null 2>&1")
752             jbdnew=$(print_jbd_stat)
753             jbd=$(( jbdnew - jbdold ))
754             echo "=== END   createmany new: $jbdnew transaction :  $jbd transactions  nfiles $nfiles time $elapsed COS=$COS"
755             avgjbd=$(( avgjbd + jbd ))
756             avgtime=$(( avgtime + elapsed ))
757         done
758         eval cos${COS}_jbd=$((avgjbd / 3))
759         eval cos${COS}_time=$((avgtime / 3))
760     done
761
762     echo "COS=0 transactions (avg): $cos0_jbd  time (avg): $cos0_time"
763     echo "COS=1 transactions (avg): $cos1_jbd  time (avg): $cos1_time"
764     [ "$cos0_jbd" != 0 ] && echo "COS=1 vs COS=0 jbd:  $((((cos1_jbd/cos0_jbd - 1)) * 100 )) %"
765     [ "$cos0_time" != 0 ] && echo "COS=1 vs COS=0 time: $((((cos1_time/cos0_time - 1)) * 100 )) %"
766
767     restore_lustre_params < $param_file
768     rm -f $param_file
769     return 0
770 }
771 run_test 33a "commit on sharing, cross crete/delete, 2 clients, benchmark"
772
773 # End commit on sharing tests
774
775 get_ost_lock_timeouts() {
776     local nodes=${1:-$(comma_list $(osts_nodes))}
777
778     local locks=$(do_nodes $nodes \
779         "lctl get_param -n ldlm.namespaces.filter-*.lock_timeouts" | calc_sum)
780
781     echo $locks
782 }
783
784 test_34() { #16129
785         local OPER
786         local lock_in
787         local lock_out
788         for OPER in notimeout timeout ; do
789                 rm $DIR1/$tfile 2>/dev/null
790                 lock_in=$(get_ost_lock_timeouts)
791                 if [ $OPER == "timeout" ] ; then
792                         for j in `seq $OSTCOUNT`; do
793                                 #define OBD_FAIL_PTLRPC_HPREQ_TIMEOUT    0x511
794                                 do_facet ost$j lctl set_param fail_loc=0x511
795                         done
796                         echo lock should expire
797                 else
798                         for j in `seq $OSTCOUNT`; do
799                                 #define OBD_FAIL_PTLRPC_HPREQ_NOTIMEOUT  0x512
800                                 do_facet ost$j lctl set_param fail_loc=0x512
801                         done
802                         echo lock should not expire
803                 fi
804                 echo writing on client1
805                 dd if=/dev/zero of=$DIR1/$tfile count=100 conv=notrunc > /dev/null 2>&1
806                 sync &
807                 echo reading on client2
808                 dd of=/dev/null if=$DIR2/$tfile > /dev/null 2>&1
809                 # wait for a lock timeout
810                 sleep 4
811                 lock_out=$(get_ost_lock_timeouts)
812                 if [ $OPER == "timeout" ] ; then
813                         if [ $lock_in == $lock_out ]; then
814                                 error "no lock timeout happened"
815                         else
816                                 echo "success"
817                         fi
818                 else
819                         if [ $lock_in != $lock_out ]; then
820                                 error "lock timeout happened"
821                         else
822                                 echo "success"
823                         fi
824                 fi
825         done
826 }
827 run_test 34 "no lock timeout under IO"
828
829 test_35() { # bug 17645
830         local generation=[]
831         local count=0
832         for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
833             g=$(awk '/generation/{print $2}' $imp/import)
834             generation[count]=$g
835             let count=count+1
836         done
837
838         mkdir -p $MOUNT1/$tfile
839         cancel_lru_locks mdc
840
841         # Let's initiate -EINTR situation by setting fail_loc and take
842         # write lock on same file from same client. This will not cause
843         # bl_ast yet as lock is already in local cache.
844 #define OBD_FAIL_LDLM_INTR_CP_AST        0x317
845         do_facet client "lctl set_param fail_loc=0x80000317"
846         local timeout=`do_facet $SINGLEMDS lctl get_param  -n timeout`
847         let timeout=timeout*3
848         local nr=0
849         while test $nr -lt 10; do
850                 log "Race attempt $nr"
851                 local blk1=`lctl get_param -n ldlm.services.ldlm_cbd.stats | awk '/ldlm_bl_callback/ {print $2}'`
852                 test "x$blk1" = "x" && blk1=0
853                 createmany -o $MOUNT2/$tfile/a 4000 &
854                 pid1=$!
855                 sleep 1
856
857                 # Let's make conflict and bl_ast
858                 ls -la $MOUNT1/$tfile > /dev/null &
859                 pid2=$!
860
861                 log "Wait for $pid1 $pid2 for $timeout sec..."
862                 sleep $timeout
863                 kill -9 $pid1 $pid2 > /dev/null 2>&1
864                 wait
865                 local blk2=`lctl get_param -n ldlm.services.ldlm_cbd.stats | awk '/ldlm_bl_callback/ {print $2}'`
866                 test "x$blk2" = "x" && blk2=0
867                 test $blk2 -gt $blk1 && break
868                 rm -fr $MOUNT1/$tfile/*
869                 cancel_lru_locks mdc
870                 let nr=nr+1
871         done
872         do_facet client "lctl set_param fail_loc=0x0"
873         df -h $MOUNT1 $MOUNT2
874         count=0
875         for imp in /proc/fs/lustre/mdc/$FSNAME-MDT*-mdc-*; do
876             g=$(awk '/generation/{print $2}' $imp/import)
877             if ! test "$g" -eq "${generation[count]}"; then
878                 error "Eviction happened on import $(basename $imp)"
879             fi
880             let count=count+1
881         done
882 }
883 run_test 35 "-EINTR cp_ast vs. bl_ast race does not evict client"
884
885 test_36() { #bug 16417
886     local SIZE
887     local SIZE_B
888     local i
889
890     mkdir -p $DIR1/$tdir
891     $LFS setstripe -c -1 $DIR1/$tdir
892     i=0
893     SIZE=50
894     let SIZE_B=SIZE*1024*1024
895
896     while [ $i -le 10 ]; do
897         lctl mark "start test"
898         local before=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
899         dd if=/dev/zero of=$DIR1/$tdir/file000 bs=1M count=$SIZE
900         sync
901         sleep 1
902         local after_dd=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
903         multiop_bg_pause $DIR2/$tdir/file000 O_r${SIZE_B}c || return 3
904         read_pid=$!
905         rm -f $DIR1/$tdir/file000
906         kill -USR1 $read_pid
907         wait $read_pid
908         sleep 1
909         local after=$($LFS df | awk '{if ($1 ~/^filesystem/) {print $5; exit} }')
910         echo "*** cycle($i) *** before($before):after_dd($after_dd):after($after)"
911         # this free space! not used
912         if [ $after_dd -ge $after ]; then
913             error "space leaked"
914             return 1;
915         fi
916         let i=i+1
917             done
918 }
919 run_test 36 "handle ESTALE/open-unlink corectly"
920
921 test_37() { # bug 18695
922         mkdir -p $DIR1/$tdir
923         multiop_bg_pause $DIR1/$tdir D_c || return 1
924         MULTIPID=$!
925         # create large directory (32kB seems enough from e2fsck, ~= 1000 files)
926         createmany -m $DIR2/$tdir/f 10000
927         # set mtime/atime backward
928         touch -t 198001010000 $DIR2/$tdir
929         kill -USR1 $MULTIPID
930         nr_files=`lfs find $DIR1/$tdir -type f | wc -l`
931         [ $nr_files -eq 10000 ] || error "$nr_files != 10000 truncated directory?"
932
933 }
934 run_test 37 "check i_size is not updated for directory on close (bug 18695) =============="
935
936 # this should be set to past
937 TEST_39_MTIME=`date -d "1 year ago" +%s`
938
939 # bug 11063
940 test_39a() {
941         local client1=${CLIENT1:-`hostname`}
942         local client2=${CLIENT2:-`hostname`}
943
944         do_node $client1 "touch $DIR1/$tfile"
945
946         do_node $client1 "touch -m -d @$TEST_39_MTIME $DIR1/$tfile"
947         local mtime1=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
948         [ "$mtime1" = $TEST_39_MTIME ] || \
949                 error "mtime is not set to past: $mtime1, should be $TEST_39_MTIME"
950
951         local d1=`do_node $client1 date +%s`
952         do_node $client1 'echo hello >> '$DIR1/$tfile
953         local d2=`do_node $client1 date +%s`
954
955         local mtime2=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
956         [ "$mtime2" -ge "$d1" ] && [ "$mtime2" -le "$d2" ] || \
957                 error "mtime is not updated on write: $d1 <= $mtime2 <= $d2"
958
959         do_node $client1 "mv $DIR1/$tfile $DIR1/$tfile-1"
960
961         for (( i=0; i < 2; i++ )) ; do
962                 local mtime3=`do_node $client2 "stat -c %Y $DIR1/$tfile-1"`
963                 [ "$mtime2" = "$mtime3" ] || \
964                         error "mtime ($mtime2) changed (to $mtime3) on rename"
965
966                 cancel_lru_locks osc
967                 if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
968         done
969 }
970 run_test 39a "test from 11063 =================================="
971
972 test_39b() {
973         local client1=${CLIENT1:-`hostname`}
974         local client2=${CLIENT2:-`hostname`}
975
976         touch $DIR1/$tfile
977
978         local mtime1=`stat -c %Y $DIR1/$tfile`
979         local mtime2=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
980
981         sleep 1
982         touch -m -d @$TEST_39_MTIME $DIR1/$tfile
983
984         for (( i=0; i < 2; i++ )) ; do
985                 local mtime3=`stat -c %Y $DIR1/$tfile`
986                 local mtime4=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
987
988                 [ "$mtime3" = "$mtime4" ] || \
989                         error "different mtime on clients: $mtime3, $mtime4"
990                 [ "$mtime3" = $TEST_39_MTIME ] || \
991                         error "lost mtime: $mtime3, should be $TEST_39_MTIME"
992
993                 cancel_lru_locks osc
994                 if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
995         done
996 }
997 run_test 39b "11063 problem 1 =================================="
998
999 test_39c() {
1000         local client1=${CLIENT1:-`hostname`}
1001         local client2=${CLIENT2:-`hostname`}
1002
1003         echo hello > $DIR1/$tfile
1004
1005         local mtime1=`stat -c %Y $DIR1/$tfile`
1006         local mtime2=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
1007         [ "$mtime1" = "$mtime2" ] || \
1008                 error "create: different mtime on clients: $mtime1, $mtime2"
1009
1010         sleep 1
1011         $TRUNCATE $DIR1/$tfile 1
1012
1013         for (( i=0; i < 2; i++ )) ; do
1014                 local mtime3=`stat -c %Y $DIR1/$tfile`
1015                 local mtime4=`do_node $client2 "stat -c %Y $DIR1/$tfile"`
1016
1017                 [ "$mtime3" = "$mtime4" ] || \
1018                         error "different mtime on clients: $mtime3, $mtime4"
1019                 [ "$mtime3" -gt $mtime2 ] || \
1020                         error "truncate did not update mtime: $mtime2, $mtime3"
1021
1022                 cancel_lru_locks osc
1023                 if [ $i = 0 ] ; then echo "repeat after cancel_lru_locks"; fi
1024         done
1025 }
1026 run_test 39c "check truncate mtime update ======================"
1027
1028 # check that pid exists hence second operation wasn't blocked by first one
1029 # if it is so then there is no conflict, return 0
1030 # else second operation is conflicting with first one, return 1
1031 check_pdo_conflict() {
1032         local pid=$1
1033         local conflict=0
1034         sleep 1 # to ensure OP1 is finished on client if OP2 is blocked by OP1
1035         if [[ `ps --pid $pid | wc -l` == 1 ]]; then
1036                 conflict=1
1037                 echo "Conflict"
1038         else
1039                 echo "No conflict"
1040         fi
1041         return $conflict
1042 }
1043
1044 # pdirop tests
1045 # test 40: check non-blocking operations
1046 test_40a() {
1047 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1048         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1049         mkdir $DIR1/$tfile &
1050         PID1=$!
1051         sleep 1
1052         touch $DIR2/$tfile-2
1053         check_pdo_conflict $PID1 || error "create is blocked"
1054         mkdir $DIR2/$tfile-3
1055         check_pdo_conflict $PID1 || error "mkdir is blocked"
1056         link $DIR2/$tfile-2 $DIR2/$tfile-4
1057         check_pdo_conflict $PID1 || error "link is blocked"
1058         mv $DIR2/$tfile-2 $DIR2/$tfile-5
1059         check_pdo_conflict $PID1 || error "rename is blocked"
1060         stat $DIR2/$tfile-3 $DIR2/$tfile-4 > /dev/null
1061         check_pdo_conflict $PID1 || error "getattr is blocked"
1062         rm $DIR2/$tfile-4 $DIR2/$tfile-5
1063         rmdir $DIR2/$tfile-3
1064         check_pdo_conflict $PID1 || error "unlink is blocked"
1065         # all operations above shouldn't wait the first one
1066         check_pdo_conflict $PID1 || error "parallel operation is blocked"
1067         wait $PID1
1068         rm -r $DIR1/*
1069         return 0
1070 }
1071 run_test 40a "pdirops: create vs others =============="
1072
1073 test_40b() {
1074 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1075         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1076         touch $DIR1/$tfile &
1077         PID1=$!
1078         sleep 1
1079         # open|create
1080         touch $DIR2/$tfile-2
1081         check_pdo_conflict $PID1 || error "create is blocked"
1082         mkdir $DIR2/$tfile-3
1083         check_pdo_conflict $PID1 || error "mkdir is blocked"
1084         link $DIR2/$tfile-2 $DIR2/$tfile-4
1085         check_pdo_conflict $PID1 || error "link is blocked"
1086         mv $DIR2/$tfile-2 $DIR2/$tfile-5
1087         check_pdo_conflict $PID1 || error "rename is blocked"
1088         stat $DIR2/$tfile-3 $DIR2/$tfile-4 > /dev/null
1089         check_pdo_conflict $PID1 || error "getattr is blocked"
1090         rm $DIR2/$tfile-4 $DIR2/$tfile-5
1091         rmdir $DIR2/$tfile-3
1092         check_pdo_conflict $PID1 || error "unlink is blocked"
1093         # all operations above shouldn't wait the first one
1094         check_pdo_conflict $PID1 || error "parallel operation is blocked"
1095         wait $PID1
1096         rm -r $DIR1/*
1097         return 0
1098 }
1099 run_test 40b "pdirops: open|create and others =============="
1100
1101 test_40c() {
1102         touch $DIR1/$tfile
1103 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1104         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1105         link $DIR1/$tfile $DIR1/$tfile-0 &
1106         PID1=$!
1107         sleep 1
1108         # open|create
1109         touch $DIR2/$tfile-2
1110         check_pdo_conflict $PID1 || error "create is blocked"
1111         mkdir $DIR2/$tfile-3
1112         check_pdo_conflict $PID1 || error "mkdir is blocked"
1113         link $DIR2/$tfile-2 $DIR2/$tfile-4
1114         check_pdo_conflict $PID1 || error "link is blocked"
1115         mv $DIR2/$tfile-2 $DIR2/$tfile-5
1116         check_pdo_conflict $PID1 || error "rename is blocked"
1117         stat $DIR2/$tfile-3 $DIR2/$tfile-4 > /dev/null
1118         check_pdo_conflict $PID1 || error "getattr is blocked"
1119         rm $DIR2/$tfile-4 $DIR2/$tfile-5
1120         rmdir $DIR2/$tfile-3
1121         check_pdo_conflict $PID1 || error "unlink is blocked"
1122         # all operations above shouldn't wait the first one
1123         check_pdo_conflict $PID1 || error "parallel operation is blocked"
1124         wait $PID1
1125         rm -r $DIR1/*
1126         return 0
1127 }
1128 run_test 40c "pdirops: link and others =============="
1129
1130 test_40d() {
1131         touch $DIR1/$tfile
1132 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1133         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1134         rm $DIR1/$tfile &
1135         PID1=$!
1136         sleep 1
1137         # open|create
1138         touch $DIR2/$tfile-2
1139         check_pdo_conflict $PID1 || error "create is blocked"
1140         mkdir $DIR2/$tfile-3
1141         check_pdo_conflict $PID1 || error "mkdir is blocked"
1142         link $DIR2/$tfile-2 $DIR2/$tfile-4
1143         check_pdo_conflict $PID1 || error "link is blocked"
1144         mv $DIR2/$tfile-2 $DIR2/$tfile-5
1145         check_pdo_conflict $PID1 || error "rename is blocked"
1146         stat $DIR2/$tfile-3 $DIR2/$tfile-4 > /dev/null
1147         check_pdo_conflict $PID1 || error "getattr is blocked"
1148         rm $DIR2/$tfile-4 $DIR2/$tfile-5
1149         rmdir $DIR2/$tfile-3
1150         check_pdo_conflict $PID1 || error "unlink is blocked"
1151         # all operations above shouldn't wait the first one
1152         check_pdo_conflict $PID1 || error "parallel operation is blocked"
1153         wait $PID1
1154         return 0
1155 }
1156 run_test 40d "pdirops: unlink and others =============="
1157
1158 test_40e() {
1159         touch $DIR1/$tfile
1160 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1161         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1162         mv $DIR1/$tfile $DIR1/$tfile-0 &
1163         PID1=$!
1164         sleep 1
1165         # open|create
1166         touch $DIR2/$tfile-2
1167         check_pdo_conflict $PID1 || error "create is blocked"
1168         mkdir $DIR2/$tfile-3
1169         check_pdo_conflict $PID1 || error "mkdir is blocked"
1170         link $DIR2/$tfile-2 $DIR2/$tfile-4
1171         check_pdo_conflict $PID1 || error "link is blocked"
1172         stat $DIR2/$tfile-3 $DIR2/$tfile-4 > /dev/null
1173         check_pdo_conflict $PID1 || error "getattr is blocked"
1174         rm $DIR2/$tfile-4 $DIR2/$tfile-2
1175         rmdir $DIR2/$tfile-3
1176         check_pdo_conflict $PID1 || error "unlink is blocked"
1177         # all operations above shouldn't wait the first one
1178         check_pdo_conflict $PID1 || error "parallel operation is blocked"
1179         wait $PID1
1180         rm -r $DIR1/*
1181         return 0
1182 }
1183 run_test 40e "pdirops: rename and others =============="
1184
1185 # test 41: create blocking operations
1186 test_41a() {
1187 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1188         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1189         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1190         PID1=$!
1191         sleep 1
1192         mkdir $DIR2/$tfile && error "mkdir must fail"
1193         check_pdo_conflict $PID1 && { wait $PID1; echo "mkdir isn't blocked"; }
1194         rm -r $DIR1/*
1195         return 0
1196 }
1197 run_test 41a "pdirops: create vs mkdir =============="
1198
1199 test_41b() {
1200 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1201         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1202         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1203         PID1=$!
1204         sleep 1
1205         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
1206         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1207         rm -r $DIR1/*
1208         return 0
1209 }
1210 run_test 41b "pdirops: create vs create =============="
1211
1212 test_41c() {
1213         touch $DIR1/$tfile-2
1214 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1215         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1216         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1217         PID1=$!
1218         sleep 1
1219         link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
1220         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1221         rm -r $DIR1/*
1222         return 0
1223 }
1224 run_test 41c "pdirops: create vs link =============="
1225
1226 test_41d() {
1227 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1228         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1229         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1230         PID1=$!
1231         sleep 1
1232         rm $DIR2/$tfile || error "unlink must succeed"
1233         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1234         rm -r $DIR1/*
1235         return 0
1236 }
1237 run_test 41d "pdirops: create vs unlink =============="
1238
1239 test_41e() {
1240         touch $DIR1/$tfile-2
1241 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1242         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1243         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1244         PID1=$!
1245         sleep 1
1246         mv $DIR2/$tfile-2 $DIR2/$tfile || error "rename must succeed"
1247         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1248         rm -r $DIR1/*
1249         return 0
1250 }
1251 run_test 41e "pdirops: create and rename (tgt) =============="
1252
1253 test_41f() {
1254 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1255         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1256         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1257         PID1=$!
1258         sleep 1
1259         mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
1260         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1261         rm -r $DIR1/*
1262         return 0
1263 }
1264 run_test 41f "pdirops: create and rename (src) =============="
1265
1266 test_41g() {
1267 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1268         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1269         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1270         PID1=$!
1271         sleep 1
1272         stat $DIR2/$tfile > /dev/null || error "stat must succeed"
1273         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1274         rm -r $DIR1/*
1275         return 0
1276 }
1277 run_test 41g "pdirops: create vs getattr =============="
1278
1279 test_41h() {
1280 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1281         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1282         multiop $DIR1/$tfile oO_CREAT:O_RDWR:c &
1283         PID1=$!
1284         sleep 1
1285         ls -lia $DIR2/ > /dev/null
1286         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1287         rm -r $DIR1/*
1288         return 0
1289 }
1290 run_test 41h "pdirops: create vs readdir =============="
1291
1292 # test 42: unlink and blocking operations
1293 test_42a() {
1294 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1295         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1296         mkdir $DIR1/$tfile &
1297         PID1=$!
1298         sleep 1
1299         mkdir $DIR2/$tfile && error "mkdir must fail"
1300         check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
1301         rm -r $DIR1/*
1302         return 0
1303 }
1304 run_test 42a "pdirops: mkdir vs mkdir =============="
1305
1306 test_42b() {
1307 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1308         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1309         mkdir $DIR1/$tfile &
1310         PID1=$!
1311         sleep 1
1312         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
1313         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1314         rm -r $DIR1/*
1315         return 0
1316 }
1317 run_test 42b "pdirops: mkdir vs create =============="
1318
1319 test_42c() {
1320         touch $DIR1/$tfile-2
1321 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1322         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1323         mkdir $DIR1/$tfile &
1324         PID1=$!
1325         sleep 1
1326         link $DIR2/$tfile-2 $DIR2/$tfile && error "link must fail"
1327         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1328         rm -r $DIR1/*
1329         return 0
1330 }
1331 run_test 42c "pdirops: mkdir vs link =============="
1332
1333 test_42d() {
1334 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1335         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1336         mkdir $DIR1/$tfile &
1337         PID1=$!
1338         sleep 1
1339         rmdir $DIR2/$tfile || error "unlink must succeed"
1340         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1341         rm -r $DIR1/*
1342         return 0
1343 }
1344 run_test 42d "pdirops: mkdir vs unlink =============="
1345
1346 test_42e() {
1347         touch $DIR1/$tfile-2
1348 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1349         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1350         mkdir $DIR1/$tfile &
1351         PID1=$!
1352         sleep 1
1353         mv -T $DIR2/$tfile-2 $DIR2/$tfile && error "rename must fail"
1354         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1355         rm -r $DIR1/*
1356         return 0
1357 }
1358 run_test 42e "pdirops: mkdir and rename (tgt) =============="
1359
1360 test_42f() {
1361 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1362         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1363         mkdir $DIR1/$tfile &
1364         PID1=$!
1365         sleep 1
1366         mv $DIR2/$tfile $DIR2/$tfile-2 || error "rename must succeed"
1367         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1368         rm -r $DIR1/*
1369         return 0
1370 }
1371 run_test 42f "pdirops: mkdir and rename (src) =============="
1372
1373 test_42g() {
1374 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1375         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1376         mkdir $DIR1/$tfile &
1377         PID1=$!
1378         sleep 1
1379         stat $DIR2/$tfile > /dev/null || error "stat must succeed"
1380         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1381         rm -r $DIR1/*
1382         return 0
1383 }
1384 run_test 42g "pdirops: mkdir vs getattr =============="
1385
1386 test_42h() {
1387 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1388         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1389         mkdir $DIR1/$tfile &
1390         PID1=$!
1391         sleep 1
1392         ls -lia $DIR2/ > /dev/null
1393         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1394         rm -r $DIR1/*
1395         return 0
1396 }
1397 run_test 42h "pdirops: mkdir vs readdir =============="
1398
1399 # test 43: unlink and blocking operations
1400 test_43a() {
1401         touch $DIR1/$tfile
1402 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1403         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1404         rm $DIR1/$tfile &
1405         PID1=$!
1406         sleep 1
1407         mkdir $DIR2/$tfile || error "mkdir must succeed"
1408         check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
1409         rm -r $DIR1/*
1410         return 0
1411 }
1412 run_test 43a "pdirops: unlink vs mkdir =============="
1413
1414 test_43b() {
1415         touch $DIR1/$tfile
1416 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1417         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1418         rm $DIR1/$tfile &
1419         PID1=$!
1420         sleep 1
1421         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
1422         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1423         rm -r $DIR1/*
1424         return 0
1425 }
1426 run_test 43b "pdirops: unlink vs create =============="
1427
1428 test_43c() {
1429         touch $DIR1/$tfile
1430         touch $DIR1/$tfile-2
1431 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1432         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1433         rm $DIR1/$tfile &
1434         PID1=$!
1435         sleep 1
1436         link $DIR2/$tfile-2 $DIR2/$tfile || error "link must succeed"
1437         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1438         rm -r $DIR1/*
1439         return 0
1440 }
1441 run_test 43c "pdirops: unlink vs link =============="
1442
1443 test_43d() {
1444         touch $DIR1/$tfile
1445 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1446         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1447         rm $DIR1/$tfile &
1448         PID1=$!
1449         sleep 1
1450         rm $DIR2/$tfile && error "unlink must fail"
1451         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1452         rm -r $DIR1/*
1453         return 0
1454 }
1455 run_test 43d "pdirops: unlink vs unlink =============="
1456
1457 test_43e() {
1458         touch $DIR1/$tfile
1459         touch $DIR1/$tfile-2
1460 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1461         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1462         rm $DIR1/$tfile &
1463         PID1=$!
1464         sleep 1
1465         mv -u $DIR2/$tfile-2 $DIR2/$tfile || error "rename must succeed"
1466         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1467         rm -r $DIR1/*
1468         return 0
1469 }
1470 run_test 43e "pdirops: unlink and rename (tgt) =============="
1471
1472 test_43f() {
1473         touch $DIR1/$tfile
1474 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1475         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1476         rm $DIR1/$tfile &
1477         PID1=$!
1478         sleep 1
1479         mv $DIR2/$tfile $DIR2/$tfile-2 && error "rename must fail"
1480         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1481         rm -r $DIR1/*
1482         return 0
1483 }
1484 run_test 43f "pdirops: unlink and rename (src) =============="
1485
1486 test_43g() {
1487         touch $DIR1/$tfile
1488 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1489         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1490         rm $DIR1/$tfile &
1491         PID1=$!
1492         sleep 1
1493         stat $DIR2/$tfile > /dev/null && error "stat must fail"
1494         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1495         rm -r $DIR1/*
1496         return 0
1497 }
1498 run_test 43g "pdirops: unlink vs getattr =============="
1499
1500 test_43h() {
1501         touch $DIR1/$tfile
1502 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1503         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1504         rm $DIR1/$tfile &
1505         PID1=$!
1506         sleep 1
1507         ls -lia $DIR2/ > /dev/null
1508         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1509         rm -r $DIR1/*
1510         return 0
1511 }
1512 run_test 43h "pdirops: unlink vs readdir =============="
1513
1514 # test 44: rename tgt and blocking operations
1515 test_44a() {
1516         touch $DIR1/$tfile-2
1517 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2   0x146
1518         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1519         mv $DIR1/$tfile-2 $DIR1/$tfile &
1520         PID1=$!
1521         sleep 1
1522         mkdir $DIR2/$tfile && error "mkdir must fail"
1523         check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
1524         rm -r $DIR1/*
1525         return 0
1526 }
1527 run_test 44a "pdirops: rename tgt vs mkdir =============="
1528
1529 test_44b() {
1530         touch $DIR1/$tfile-2
1531 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1532         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1533         mv $DIR1/$tfile-2 $DIR1/$tfile &
1534         PID1=$!
1535         sleep 1
1536         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
1537         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1538         rm -r $DIR1/*
1539         return 0
1540 }
1541 run_test 44b "pdirops: rename tgt vs create =============="
1542
1543 test_44c() {
1544         touch $DIR1/$tfile-2
1545         touch $DIR1/$tfile-3
1546 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1547         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1548         mv $DIR1/$tfile-2 $DIR1/$tfile &
1549         PID1=$!
1550         sleep 1
1551         link $DIR2/$tfile-3 $DIR2/$tfile && error "link must fail"
1552         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1553         rm -r $DIR1/*
1554         return 0
1555 }
1556 run_test 44c "pdirops: rename tgt vs link =============="
1557
1558 test_44d() {
1559         touch $DIR1/$tfile-2
1560 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1561         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1562         mv $DIR1/$tfile-2 $DIR1/$tfile &
1563         PID1=$!
1564         sleep 1
1565         rm $DIR2/$tfile || error "unlink must succeed"
1566         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1567         rm -r $DIR1/*
1568         return 0
1569 }
1570 run_test 44d "pdirops: rename tgt vs unlink =============="
1571
1572 test_44e() {
1573         touch $DIR1/$tfile
1574         touch $DIR1/$tfile-2
1575         touch $DIR1/$tfile-3
1576 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1577         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1578         mv $DIR1/$tfile-2 $DIR1/$tfile &
1579         PID1=$!
1580         sleep 1
1581         mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
1582         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1583         rm -r $DIR1/*
1584         return 0
1585 }
1586 run_test 44e "pdirops: rename tgt and rename (tgt) =============="
1587
1588 test_44f() {
1589         touch $DIR1/$tfile-2
1590         touch $DIR1/$tfile-3
1591 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1592         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1593         mv $DIR1/$tfile-2 $DIR1/$tfile &
1594         PID1=$!
1595         sleep 1
1596         mv $DIR2/$tfile $DIR2/$tfile-3 || error "rename must succeed"
1597         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1598         rm -r $DIR1/*
1599         return 0
1600 }
1601 run_test 44f "pdirops: rename tgt and rename (src) =============="
1602
1603 test_44g() {
1604         touch $DIR1/$tfile-2
1605 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1606         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1607         mv $DIR1/$tfile-2 $DIR1/$tfile &
1608         PID1=$!
1609         sleep 1
1610         stat $DIR2/$tfile > /dev/null || error "stat must succeed"
1611         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1612         rm -r $DIR1/*
1613         return 0
1614 }
1615 run_test 44g "pdirops: rename tgt vs getattr =============="
1616
1617 test_44h() {
1618         touch $DIR1/$tfile-2
1619 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK2    0x146
1620         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000146
1621         mv $DIR1/$tfile-2 $DIR1/$tfile &
1622         PID1=$!
1623         sleep 1
1624         ls -lia $DIR2/ > /dev/null
1625         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1626         rm -r $DIR1/*
1627         return 0
1628 }
1629 run_test 44h "pdirops: rename tgt vs readdir =============="
1630
1631 # test 45: rename src and blocking operations
1632 test_45a() {
1633         touch $DIR1/$tfile
1634 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1635         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1636         mv $DIR1/$tfile $DIR1/$tfile-2 &
1637         PID1=$!
1638         sleep 1
1639         mkdir $DIR2/$tfile || error "mkdir must succeed"
1640         check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
1641         rm -r $DIR1/*
1642         return 0
1643 }
1644 run_test 45a "pdirops: rename src vs mkdir =============="
1645
1646 test_45b() {
1647         touch $DIR1/$tfile
1648 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1649         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1650         mv $DIR1/$tfile $DIR1/$tfile-2 &
1651         PID1=$!
1652         sleep 1
1653         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c || error "create must succeed"
1654         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1655         rm -r $DIR1/*
1656         return 0
1657 }
1658 run_test 45b "pdirops: rename src vs create =============="
1659
1660 test_45c() {
1661         touch $DIR1/$tfile
1662         touch $DIR1/$tfile-3
1663 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1664         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1665         mv $DIR1/$tfile $DIR1/$tfile-2 &
1666         PID1=$!
1667         sleep 1
1668         link $DIR2/$tfile-3 $DIR2/$tfile || error "link must succeed"
1669         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1670         rm -r $DIR1/*
1671         return 0
1672 }
1673 run_test 45c "pdirops: rename src vs link =============="
1674
1675 test_45d() {
1676         touch $DIR1/$tfile
1677 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1678         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1679         mv $DIR1/$tfile $DIR1/$tfile-2 &
1680         PID1=$!
1681         sleep 1
1682         rm $DIR2/$tfile && error "unlink must fail"
1683         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1684         rm -r $DIR1/*
1685         return 0
1686 }
1687 run_test 45d "pdirops: rename src vs unlink =============="
1688
1689 test_45e() {
1690         touch $DIR1/$tfile
1691         touch $DIR1/$tfile-3
1692 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1693         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1694         mv $DIR1/$tfile $DIR1/$tfile-2 &
1695         PID1=$!
1696         sleep 1
1697         mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
1698         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1699         rm -r $DIR1/*
1700         return 0
1701 }
1702 run_test 45e "pdirops: rename src and rename (tgt) =============="
1703
1704 test_45f() {
1705         touch $DIR1/$tfile
1706 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1707         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1708         mv $DIR1/$tfile $DIR1/$tfile-2 &
1709         PID1=$!
1710         sleep 1
1711         mv $DIR2/$tfile $DIR2/$tfile-3 && error "rename must fail"
1712         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1713         rm -r $DIR1/*
1714         return 0
1715 }
1716 run_test 45f "pdirops: rename src and rename (src) =============="
1717
1718 test_45g() {
1719         touch $DIR1/$tfile
1720 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1721         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1722         mv $DIR1/$tfile $DIR1/$tfile-2 &
1723         PID1=$!
1724         sleep 1
1725         stat $DIR2/$tfile > /dev/null && "stat must fail"
1726         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1727         rm -r $DIR1/*
1728         return 0
1729 }
1730 run_test 45g "pdirops: rename src vs getattr =============="
1731
1732 test_45h() {
1733         touch $DIR1/$tfile
1734 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1735         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1736         mv $DIR1/$tfile $DIR1/$tfile-2 &
1737         PID1=$!
1738         sleep 1
1739         ls -lia $DIR2/ > /dev/null
1740         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1741         rm -r $DIR1/*
1742         return 0
1743 }
1744 run_test 45h "pdirops: unlink vs readdir =============="
1745
1746 # test 46: link and blocking operations
1747 test_46a() {
1748         touch $DIR1/$tfile-2
1749 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1750         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1751         link $DIR1/$tfile-2 $DIR1/$tfile &
1752         PID1=$!
1753         sleep 1
1754         mkdir $DIR2/$tfile && error "mkdir must fail"
1755         check_pdo_conflict $PID1 && { wait $PID1; error "mkdir isn't blocked"; }
1756         rm -r $DIR1/*
1757         return 0
1758 }
1759 run_test 46a "pdirops: link vs mkdir =============="
1760
1761 test_46b() {
1762         touch $DIR1/$tfile-2
1763 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1764         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1765         link $DIR1/$tfile-2 $DIR1/$tfile &
1766         PID1=$!
1767         sleep 1
1768         multiop $DIR2/$tfile oO_CREAT:O_EXCL:c && error "create must fail"
1769         check_pdo_conflict $PID1 && { wait $PID1; error "create isn't blocked"; }
1770         rm -r $DIR1/*
1771         return 0
1772 }
1773 run_test 46b "pdirops: link vs create =============="
1774
1775 test_46c() {
1776         touch $DIR1/$tfile-2
1777 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1778         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1779         link $DIR1/$tfile-2 $DIR1/$tfile &
1780         PID1=$!
1781         sleep 1
1782         link $DIR2/$tfile $DIR2/$tfile && error "link must fail"
1783         check_pdo_conflict $PID1 && { wait $PID1; error "link isn't blocked"; }
1784         rm -r $DIR1/*
1785         return 0
1786 }
1787 run_test 46c "pdirops: link vs link =============="
1788
1789 test_46d() {
1790         touch $DIR1/$tfile-2
1791 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1792         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1793         link $DIR1/$tfile-2 $DIR1/$tfile &
1794         PID1=$!
1795         sleep 1
1796         rm $DIR2/$tfile || error "unlink must succeed"
1797         check_pdo_conflict $PID1 && { wait $PID1; error "unlink isn't blocked"; }
1798         rm -r $DIR1/*
1799         return 0
1800 }
1801 run_test 46d "pdirops: link vs unlink =============="
1802
1803 test_46e() {
1804         touch $DIR1/$tfile-2
1805         touch $DIR1/$tfile-3
1806 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1807         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1808         link $DIR1/$tfile-2 $DIR1/$tfile &
1809         PID1=$!
1810         sleep 1
1811         mv $DIR2/$tfile-3 $DIR2/$tfile || error "rename must succeed"
1812         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1813         rm -r $DIR1/*
1814         return 0
1815 }
1816 run_test 46e "pdirops: link and rename (tgt) =============="
1817
1818 test_46f() {
1819         touch $DIR1/$tfile-2
1820         touch $DIR1/$tfile-3
1821 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1822         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1823         link $DIR1/$tfile-2 $DIR1/$tfile &
1824         PID1=$!
1825         sleep 1
1826         mv $DIR2/$tfile $DIR2/$tfile-3 || error "rename must succeed"
1827         check_pdo_conflict $PID1 && { wait $PID1; error "rename isn't blocked"; }
1828         rm -r $DIR1/*
1829         return 0
1830 }
1831 run_test 46f "pdirops: link and rename (src) =============="
1832
1833 test_46g() {
1834         touch $DIR1/$tfile-2
1835 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1836         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1837         link $DIR1/$tfile-2 $DIR1/$tfile &
1838         PID1=$!
1839         sleep 1
1840         stat $DIR2/$tfile > /dev/null || error "stat must succeed"
1841         check_pdo_conflict $PID1 && { wait $PID1; error "getattr isn't blocked"; }
1842         rm -r $DIR1/*
1843         return 0
1844 }
1845 run_test 46g "pdirops: link vs getattr =============="
1846
1847 test_46h() {
1848         touch $DIR1/$tfile-2
1849 #define OBD_FAIL_ONCE|OBD_FAIL_MDS_PDO_LOCK    0x145
1850         do_facet $SINGLEMDS lctl set_param fail_loc=0x80000145
1851         link $DIR1/$tfile-2 $DIR1/$tfile &
1852         PID1=$!
1853         sleep 1
1854         ls -lia $DIR2/ > /dev/null
1855         check_pdo_conflict $PID1 && { wait $PID1; error "readdir isn't blocked"; }
1856         rm -r $DIR1/*
1857         return 0
1858 }
1859 run_test 46h "pdirops: link vs readdir =============="
1860
1861 test_50() {
1862         trunc_size=4096
1863         dd if=/dev/zero of=$DIR1/$tfile bs=1K count=10
1864 #define OBD_FAIL_OSC_CP_ENQ_RACE         0x410
1865         do_facet client "lctl set_param fail_loc=0x410"
1866         $TRUNCATE $DIR2/$tfile $trunc_size
1867         do_facet client "lctl set_param fail_loc=0x0"
1868         sleep 3
1869         size=`stat -c %s $DIR2/$tfile`
1870         [ $size -eq $trunc_size ] || error "wrong size"
1871 }
1872 run_test 50 "osc lvb attrs: enqueue vs. CP AST =============="
1873
1874 log "cleanup: ======================================================"
1875
1876 [ "$(mount | grep $MOUNT2)" ] && umount $MOUNT2
1877
1878 complete $(basename $0) $SECONDS
1879 check_and_cleanup_lustre
1880 exit_status